import java.awt.*;
import java.applet.*;

public class colpisci extends Applet implements Runnable{
	int larghezza,altezza,lato,difficolta,movx,movy,cont;
	boolean colpito;
	Point Q;
	Font f;
	Thread esec;
	
	public void init(){
		larghezza=size().width;
		altezza=size().height;
		Q= new Point((int)(larghezza/2),(int)(altezza/2));			
		lato=30;
		colpito=false;
		setBackground(Color.white);
		f=new Font("Verdana",Font.BOLD,20);
		difficolta=1;
		cont=0;
	}
	
	public void start() {
		if (esec == null) {
  		esec=new Thread(this);
  		esec.start(); 
 		}
	}

	public void stop(){
		if (esec != null){
   		esec.stop();
   		esec=null; 
 		}
	}

	public void run() {
    while (esec!=null){
    	movx=(int)((Math.random()*64-32));
    	movy=(int)((Math.random()*64-32));
    	if ((Q.x+movx>lato/2)&&(Q.x+movx<larghezza-lato/2)) Q.x=Q.x+movx;
    	if ((Q.y+movy>lato/2)&&(Q.y+movy<altezza-lato/2-20)) Q.y=Q.y+movy;
    	repaint();
      try { Thread.sleep((int)(200/difficolta));}
    	catch (InterruptedException e) { }
    }
	}
	
	public boolean mouseDown(Event evt, int x, int y){
		if ((Math.abs(Q.x-x)<lato/2)&&(Math.abs(Q.y-y)<lato/2)){
			colpito=true;
			stop();
			cont=cont+1;
			repaint();
		}
		return true;
	}
	
	public boolean mouseUp(Event evt, int x, int y){
		colpito=false;
		start();
		repaint();
		return true;
	}
	
	public void paint(Graphics g){
		g.setFont(f);

		if (colpito)
		{
			g.setColor(Color.red);
			g.fillRect((int)(Q.x-lato/2),(int)(Q.y-lato/2),lato,lato);
		}
		else
		{
			g.setColor(Color.lightGray);
			g.drawRect((int)(Q.x-lato/2),(int)(Q.y-lato/2),lato,lato);
		}
		
		g.setColor(Color.black);
		g.drawLine(0,altezza-20,larghezza,altezza-20);
		g.setColor(Color.blue);
		if (colpito) g.drawString("COLPITO!",larghezza-140,altezza-4);
		g.drawString(""+cont,20,altezza-4);

	}
}